FROM mcr.microsoft.com/dotnet/core/sdk:3.1 AS build
WORKDIR /app

#Add ports
ENV ASPNETCORE_URLS=http://*:5000
EXPOSE 5000

#For perfomance download NuGet packeges, and cashe all on this layer
COPY *.sln .
COPY */*.csproj ./
RUN for file in $(ls *.csproj); do mkdir -p ${file%.*} && mv $file ${file%.*}; done
RUN dotnet restore

#Copy other code and buil app
COPY . ./build
WORKDIR /app/build
RUN dotnet publish -c Release -o out

#Run app
FROM mcr.microsoft.com/dotnet/core/aspnet:3.1 AS runtime
WORKDIR /app
COPY --from=build /app/build/out ./
ENTRYPOINT ["dotnet", "Otus.Teaching.PromoCodeFactory.WebHost.dll"]